From d6337d199108244d838dab8e60186fc0b8e844ce Mon Sep 17 00:00:00 2001
From: Coly Li <coly.li@suse.de>
Date: Wed, 24 Mar 2010 16:32:56 +0800
Subject: [PATCH 15/15] dx_dirs: enable metaecc and indexed-dirs support as default features

metaecc feature enables ECC checking for meta data, which helps the file
system consistency. indexed-dirs feature enables indexed tree for
directories, which improves lookup performance for large scale
directories.

This patch enables metaecc and indexed-dirs support as default features.

Signed-off-by: Coly Li <coly.li@suse.de>
Cc: Mark Fasheh <mfasheh@suse.com>
---
 libocfs2/feature_string.c  |   18 ++++++++++++++----
 mkfs.ocfs2/mkfs.ocfs2.8.in |    2 +-
 2 files changed, 15 insertions(+), 5 deletions(-)

Index: ocfs2-tools/libocfs2/feature_string.c
===================================================================
--- ocfs2-tools.orig/libocfs2/feature_string.c
+++ ocfs2-tools/libocfs2/feature_string.c
@@ -76,7 +76,9 @@ static ocfs2_fs_options feature_level_de
 	{OCFS2_FEATURE_COMPAT_BACKUP_SB | OCFS2_FEATURE_COMPAT_JBD2_SB,
 	 OCFS2_FEATURE_INCOMPAT_SPARSE_ALLOC |
 	 OCFS2_FEATURE_INCOMPAT_INLINE_DATA |
-	 OCFS2_FEATURE_INCOMPAT_XATTR,
+	 OCFS2_FEATURE_INCOMPAT_XATTR |
+	 OCFS2_FEATURE_INCOMPAT_META_ECC |
+	 OCFS2_FEATURE_INCOMPAT_INDEXED_DIRS,
 	 OCFS2_FEATURE_RO_COMPAT_UNWRITTEN},  /* OCFS2_FEATURE_LEVEL_DEFAULT */
 
 	{OCFS2_FEATURE_COMPAT_BACKUP_SB | OCFS2_FEATURE_COMPAT_JBD2_SB,
@@ -100,25 +102,33 @@ static ocfs2_fs_options mkfstypes_featur
 	{OCFS2_FEATURE_COMPAT_BACKUP_SB | OCFS2_FEATURE_COMPAT_JBD2_SB,
 	 OCFS2_FEATURE_INCOMPAT_SPARSE_ALLOC |
 	 OCFS2_FEATURE_INCOMPAT_INLINE_DATA |
-	 OCFS2_FEATURE_INCOMPAT_XATTR,
+	 OCFS2_FEATURE_INCOMPAT_XATTR |
+	 OCFS2_FEATURE_INCOMPAT_META_ECC |
+	 OCFS2_FEATURE_INCOMPAT_INDEXED_DIRS,
 	 OCFS2_FEATURE_RO_COMPAT_UNWRITTEN},  /* OCFS2_MKFSTYPE_DEFAULT */
 
 	{OCFS2_FEATURE_COMPAT_BACKUP_SB | OCFS2_FEATURE_COMPAT_JBD2_SB,
 	 OCFS2_FEATURE_INCOMPAT_SPARSE_ALLOC |
 	 OCFS2_FEATURE_INCOMPAT_INLINE_DATA |
-	 OCFS2_FEATURE_INCOMPAT_XATTR,
+	 OCFS2_FEATURE_INCOMPAT_XATTR |
+	 OCFS2_FEATURE_INCOMPAT_META_ECC |
+	 OCFS2_FEATURE_INCOMPAT_INDEXED_DIRS,
 	 OCFS2_FEATURE_RO_COMPAT_UNWRITTEN},  /* OCFS2_MKFSTYPE_DATAFILES */
 
 	{OCFS2_FEATURE_COMPAT_BACKUP_SB | OCFS2_FEATURE_COMPAT_JBD2_SB,
 	 OCFS2_FEATURE_INCOMPAT_SPARSE_ALLOC |
 	 OCFS2_FEATURE_INCOMPAT_INLINE_DATA |
-	 OCFS2_FEATURE_INCOMPAT_XATTR,
+	 OCFS2_FEATURE_INCOMPAT_XATTR |
+	 OCFS2_FEATURE_INCOMPAT_META_ECC |
+	 OCFS2_FEATURE_INCOMPAT_INDEXED_DIRS,
 	 OCFS2_FEATURE_RO_COMPAT_UNWRITTEN},  /* OCFS2_MKFSTYPE_MAIL */
 
 	{OCFS2_FEATURE_COMPAT_BACKUP_SB | OCFS2_FEATURE_COMPAT_JBD2_SB,
 	 OCFS2_FEATURE_INCOMPAT_SPARSE_ALLOC |
 	 OCFS2_FEATURE_INCOMPAT_INLINE_DATA |
 	 OCFS2_FEATURE_INCOMPAT_XATTR |
+	 OCFS2_FEATURE_INCOMPAT_META_ECC |
+	 OCFS2_FEATURE_INCOMPAT_INDEXED_DIRS |
 	 OCFS2_FEATURE_INCOMPAT_REFCOUNT_TREE,
 	 OCFS2_FEATURE_RO_COMPAT_UNWRITTEN},  /* OCFS2_MKFSTYPE_VMSTORE */
 };
Index: ocfs2-tools/mkfs.ocfs2/mkfs.ocfs2.8.in
===================================================================
--- ocfs2-tools.orig/mkfs.ocfs2/mkfs.ocfs2.8.in
+++ ocfs2-tools/mkfs.ocfs2/mkfs.ocfs2.8.in
@@ -191,7 +191,7 @@ Chooses fewer features but ensures that
 .RS 1.2i
 .TP
 \fBdefault\fR
-The default feature set tries to strike a balance between providing new features and maintaining compatibility with relatively recent versions of \fIOCFS2\fR. It currently enables \fBsparse\fR, \fBunwritten\fR \fBinline-data\fR and \fBxattr\fR. It also enables \fBrefcount\fR for the \fIvmstore\fR volumes.
+The default feature set tries to strike a balance between providing new features and maintaining compatibility with relatively recent versions of \fIOCFS2\fR. It currently enables \fBsparse\fR, \fBunwritten\fR, \fBinline-data\fR, \fRxattr\fR, \fRmetaecc\fR, and \fRindexed-dirs\fR. It also enables \fBrefcount\fR for the \fIvmstore\fR volumes.
 .RE
 .RS 1.2i
 .TP
